<?php
/**
* @package msta calendar extension
*/

namespace msta\calendar\migrations;

class mig1 extends \phpbb\db\migration\migration {
  public function update_schema () {
    return array(
      'add_tables'  => array(
        $this->table_prefix.'calendar' => array(
          'COLUMNS' => array(
            'post_id' => array('UINT', 0),
            'event_name' => array('VCHAR:255', ''),
            'location' => array('VCHAR:255', ''),
            'url' => array('VCHAR:255', ''),
            'description' => array('TEXT', null),
            'category' => array('USINT', 0),
            'promoter' => array('UINT', 0),
            'public' => array('BOOL', 0),
            'date_from' => array('VCHAR:10', ''),
            'time_from' => array('VCHAR:5', ''),
            'date_to' => array('VCHAR:10', ''),
            'time_to' => array('VCHAR:5', ''),
            'repeat_mode' => array('TINT:1', 0),
            'repeat_nr' => array('INT:11', 0),
            'canceled' => array('BOOL', 0),
            'participants' => array('TINT:1', 0),
            'anniversary' => array('BOOL', 0),
            'uid' => array('VCHAR:255', ''),
          ),
          'PRIMARY_KEY' => array('post_id'),
        ),
        $this->table_prefix.'calendar_co_promoters' => array(
          'COLUMNS' => array(
            'post_id' => array('UINT', 0),
            'promoter' => array('UINT', 0),
            'comment' => array('TEXT', null),
          ),
          'PRIMARY_KEY' => array('post_id', 'promoter'),
        ),
        $this->table_prefix.'calendar_deleted' => array(
          'COLUMNS' => array(
            'post_id' => array('UINT', 0),
            'uid' => array('VCHAR:255', ''),
            'delete_time' => array('TIMESTAMP', 0),
            'deleted_by_user' => array('BOOL', 0),
          ),
          'PRIMARY_KEY' => array('post_id'),
        ),
        $this->table_prefix.'calendar_category' => array(
          'COLUMNS' => array(
            'category_id' => array('USINT', null, 'auto_increment'),
            'name' => array('VCHAR:40', ''),
            'color' => array('VCHAR:6', ''),
            'bcolor' => array('VCHAR:6', ''),
            'big' => array('BOOL', 0),
            'participants' => array('TINT:1', 0),
            'sort' => array('USINT', 0),
            'ics_additional' => array('VCHAR:40', ''),
          ),
          'PRIMARY_KEY' => array('category_id'),
        ),
        $this->table_prefix.'calendar_external' => array(
          'COLUMNS' => array(
            'topic_id' => array('UINT', 0),
            'source' => array('VCHAR:255', ''),
            'search_fitting_post' => array('BOOL', 0),
            'keep_uid' => array('BOOL', 1),
            'keep_past_events' => array('BOOL', 0),
            'promoter_mapping' => array('TEXT', null),
            'category_mapping' => array('TEXT', null),
            'publicity' => array('TINT:1', 0),
            'anniversarity' => array('TINT:1', 0),
            'fetch_interval' => array('UINT:11', 0),
            'trigger_pwd' => array('VCHAR:20', ''),
            'last_fetch' => array('TIMESTAMP', 0),
          ),
          'PRIMARY_KEY' => array('topic_id'),
        ),
        $this->table_prefix.'calendar_forums' => array(
          'COLUMNS' => array(
            'forum_id' => array('UINT', 0),
            'allowed' => array('BOOL', 0),
            'default_checked_for_new_topic' => array('BOOL', 0),
            'default_promoter' => array('UINT', 0),
          ),
          'PRIMARY_KEY' => array('forum_id'),
        ),
        $this->table_prefix.'calendar_participants' => array(
          'COLUMNS' => array(
            'post_id' => array('UINT', 0),
            'user_id' => array('UINT', 0),
            'participate' => array('TINT:1', 0),
            'number' => array('USINT', 1),
            'comments' => array('VCHAR:255', ''),
            'date' => array('VCHAR:20', ''),
            'event_date' => array('VCHAR:10', ''),
          ),
          'PRIMARY_KEY' => array('post_id', 'user_id', 'event_date'),
        ),
      ),
      'add_columns' => array(
        $this->table_prefix.'groups' => array(
          'calendar_settings' => array('UINT', 0),
          'calendar_category' => array('VCHAR:40', ''),
        ),
        $this->table_prefix.'users' => array(
          'calendar_password' => array('VCHAR:20', ''),
        ),
      ),
    );
  }

  public function revert_schema () {
    return array(
      'drop_tables'	=> array(
        $this->table_prefix.'calendar',
        $this->table_prefix.'calendar_co_promoters',
        $this->table_prefix.'calendar_deleted',
        $this->table_prefix.'calendar_category',
        $this->table_prefix.'calendar_external',
        $this->table_prefix.'calendar_forums',
        $this->table_prefix.'calendar_participants',
      ),
      'drop_columns' => array(
        $this->table_prefix.'groups' => array('calendar_settings', 'calendar_category'),
        $this->table_prefix.'users' => array('calendar_password'),
      ),
    );
  }

  public function update_data() {
    return array(
      array('config.add', array('calendar_birthday_on_calendar', 0)),
      array('config.add', array('calendar_for_guests', 0)),
      array('config.add', array('calendar_on_header', 1)),
      array('config.add', array('calendar_only_first_post', 0)),
      array('module.add', array(
        'acp',
        'ACP_CAT_DOT_MODS',
        'ACP_CALENDAR_TITLE',
      )),
      array('module.add', array(
        'acp',
        'ACP_CALENDAR_TITLE',
        array(
          'module_basename' => '\msta\calendar\acp\main_module',
          'modes' => array('calendar_settings', 'forum_settings', 'category_settings', 'group_settings', 'external_settings'),
        ),
      )),
    );
  }

  public function revert_data () {
    return array(
      array('config.remove', array('calendar_birthday_on_calendar')),
      array('config.remove', array('calendar_for_guests')),
      array('config.remove', array('calendar_on_header')),
      array('config.remove', array('calendar_only_first_post')),
      array('module.remove', array('acp', 0, 'ACP_CALENDAR_TITLE')),
    );
  }
}
